## nqc 3.1.r6

=== Makefile ===
--- 
+++ 
@@ -14,6 +14,9 @@
 # Portions created by David Baum are Copyright (C) 1999 David Baum.
 # All Rights Reserved.
 #
+# Portions created by John Hansen are Copyright (C) 2005 John Hansen.
+# All Rights Reserved.
+#
 #   original author:
 #		Dave Baum <dbaum@enteract.com>
 #
@@ -26,47 +29,49 @@
 .SUFFIXES: .cpp .c
 
 #
-# Pick your C++ compiler. 
-#
-CC=g++
-# CC=gcc
+# Pick your C++ compiler.
+#
+CXX ?= ${CXX}
+# CXX ?= gcc
 
 #
 # Pick your YACC processor
 #
-YACC = bison -y
-# YACC = yacc
+YACC ?= bison -y
+# YACC ?= yacc
 
 #
 # Define the FLEX processor
 #    note - lex will not work
 #
-FLEX = flex
+FLEX ?= flex
 
 # Link in any necessary C++ libraries
 #
-LIBS = -lstdc++
+LIBS ?= -lstdc++
 
 
 
 # installation information
-BINDIR=/usr/local/bin
-MANDIR=/usr/local/man/man1
-MANEXT=1
+PREFIX?=/usr/local
+BINDIR?=${PREFIX}/bin
+MANDIR?=${PREFIX}/man/man1
+MANEXT?=1
 
 
 # other commands
-CP=cp -f
-MKDIR=mkdir
-MV=mv -f
-RM=rm -f
+CP?=cp -f
+MKDIR?=mkdir
+MV?=mv -f
+RM?=rm -f
 
 # CFLAGS
-CFLAGS = -pipe -Iplatform -Ircxlib -Inqc -Icompiler -Wall -Wstrict-prototypes -Wmissing-prototypes
+#CFLAGS = -pipe -Iplatform -Ircxlib -Inqc -Icompiler -Wall -Wstrict-prototypes -Wmissing-prototypes
+CFLAGS += -Iplatform -Ircxlib -Inqc -Icompiler -Wall
 
 USBOBJ = rcxlib/RCX_USBTowerPipe_none.o
 
-	
+
 #
 # Platform specific tweaks
 #
@@ -76,22 +81,30 @@
   # Mac OSX
   LIBS += -framework IOKit -framework CoreFoundation
   USBOBJ = rcxlib/RCX_USBTowerPipe_osx.o
-  CC = c++
+  CXX = c++
 else
 ifneq (,$(strip $(findstring $(OSTYPE), Linux)))
   # Linux
-  USBOBJ = rcxlib/RCX_USBTowerPipe_linux.o
+# uncomment this next line if you have the USB tower library installed
+#  USBOBJ = rcxlib/RCX_USBTowerPipe_linux.o
   CFLAGS += -I/usr/local/include/LegoUSB -Wno-deprecated
 else
 ifneq (,$(findstring $(OSTYPE), SunOS))
   # Solaris
   CFLAGS += -DSOLARIS
 else
+ifneq (,$(strip $(findstring $(OSTYPE), FreeBSD)))
+  # FreeBSD
+  USBOBJ = rcxlib/RCX_USBTowerPipe_fbsd.o
+  DEFAULT_SERIAL_NAME = "/dev/cuad0"
+  CFLAGS += -Wno-deprecated
+else
   # default Unix build without USB support
   CFLAGS += -O6
 endif
 endif
 endif
+endif
 
 
 # this must happen after the platform tweaks just in case the platform
@@ -109,7 +122,7 @@
 
 RCXOBJ= rcxlib/RCX_Cmd.o rcxlib/RCX_Disasm.o rcxlib/RCX_Image.o \
 	rcxlib/RCX_Link.o rcxlib/RCX_Log.o rcxlib/RCX_Target.o \
-	rcxlib/RCX_PipeTransport.o rcxlib/RCX_Transport.o \
+	rcxlib/RCX_Pipe.o rcxlib/RCX_PipeTransport.o rcxlib/RCX_Transport.o \
 	rcxlib/RCX_SpyboticsLinker.o rcxlib/RCX_SerialPipe.o \
 	$(USBOBJ)
 
@@ -133,7 +146,8 @@
 	compiler/ModExpr.o compiler/EventSrcExpr.o compiler/SensorExpr.o \
 	compiler/ArrayExpr.o compiler/TaskIdExpr.o compiler/RelExpr.o compiler/LogicalExpr.o \
 	compiler/NegateExpr.o compiler/IndirectExpr.o compiler/NodeExpr.o compiler/ShiftExpr.o compiler/TernaryExpr.o \
-	compiler/VarAllocator.o compiler/VarTranslator.o compiler/Resource.o
+	compiler/VarAllocator.o compiler/VarTranslator.o compiler/Resource.o \
+	compiler/AddrOfExpr.o compiler/DerefExpr.o compiler/GosubParamStmt.o
 
 NQCOBJ = nqc/nqc.o nqc/SRecord.o nqc/DirList.o nqc/CmdLine.o
 
@@ -150,10 +164,10 @@
 	$(MKDIR) bin
 
 bin/nqc : compiler/parse.cpp $(OBJ)
-	$(CC) -o $@ $(OBJ) $(LIBS)
+	$(CXX) -o $@ $(OBJ) $(LIBS)
 
 bin/mkdata : mkdata/mkdata.cpp nqc/SRecord.cpp
-	$(CC) -o bin/mkdata -Inqc/ -Iplatform/ mkdata/mkdata.cpp nqc/SRecord.cpp
+	$(CXX) -o bin/mkdata -Inqc/ -Iplatform/ mkdata/mkdata.cpp nqc/SRecord.cpp
 
 #
 # clean up stuff
@@ -213,7 +227,7 @@
 # general rule for compiling
 #
 .cpp.o:
-	$(CC) -c $(CFLAGS) $< -o $*.o 
+	$(CXX) -c $(CFLAGS) $< -o $*.o
 
 
 #
@@ -228,7 +242,7 @@
 
 
 #
-# This is used to create a default parser, lexer, and nqh files for later use. 
+# This is used to create a default parser, lexer, and nqh files for later use.
 # You shouldn't need to do this as part of a port.
 #
 DEF_FILES = compiler/parse.cpp compiler/lexer.cpp compiler/rcx1_nqh.h compiler/rcx2_nqh.h
