=== debian/changelog ===
nqc (4.0.1+dfsg-1) unstable; urgency=medium

  * Change upstream to BrickBot NQC project.
  * New upstream version 4.0.1+dfsg:
    - Update debian/copyright.
    - Refresh patches, remove patches applied upstream or no longer needed.
    - Update build.
    - This fixes the build dependencies problem (Closes: #1105494).
  * Drop the Debian specific default serial port path /dev/rcx.
    NQC now defaults to using USB which is more common on today computers.
    If you use a serial port, give the actual serial port path directly.

 -- Nicolas Schodet <nico@ni.fr.eu.org>  Thu, 14 Aug 2025 08:45:38 +0200

nqc (3.1.r6-13) unstable; urgency=medium

  * debian/README.Debian: replace dead links.
  * Drop dpkg-dev build dependency, which is a build-essential.
  * Upgrade to HTTPS for Homepage, copyright, watch and changelog.
  * Add 1080-fix-manpage-url.patch, replacing or removing dead links in manual
    page.
  * Enable Salsa CI using default template.
  * Update debian/copyright for debian part.
  * Use CXXFLAGS and CPPFLAGS to define CFLAGS, which is the only one used by
    upstream Makefile.
  * Add blhc ignore-line-regexp for bin/mkdata which is not installed.
  * Update Standards-Version to 4.7.2, no change needed.
  * Add myself as an uploader.

 -- Nicolas Schodet <nico@ni.fr.eu.org>  Fri, 04 Apr 2025 00:55:29 +0200

nqc (3.1.r6-12) unstable; urgency=medium

  * Correct file name for Appstream metainfo XML content.
  * Set field Upstream-Contact in debian/copyright.
  * Remove obsolete field Contact from debian/upstream/metadata
    (already present in machine-readable debian/copyright).
  * Update standards version to 4.7.0, no changes needed.

 -- Petter Reinholdtsen <pere@debian.org>  Wed, 14 Aug 2024 08:53:31 +0200

nqc (3.1.r6-11) unstable; urgency=medium

  * Removed unused d/lintian-overrides.
  * Adjusted d/rules to build hardened binaries.

 -- Petter Reinholdtsen <pere@debian.org>  Wed, 06 Oct 2021 08:23:19 +0200

nqc (3.1.r6-10) unstable; urgency=medium

  * Added 1070-typos-code.patch to fix some code typos discovered by Lintian.
  * Switched d/watch to version 4.
  * Switched appstream metadata license back to MIT and adjusted d/copyright.

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 03 Oct 2021 08:15:43 +0200

nqc (3.1.r6-9) unstable; urgency=medium

  * Fixed description typo in apply-rcx_changes.patch.
  * Renamed patches according to wanted patch naming scheme.
  * Added upstream contact emali to upstream metadata.
  * Adjusted license info in appstream metadata file to match d/copyright.

 -- Petter Reinholdtsen <pere@debian.org>  Wed, 29 Sep 2021 18:17:11 +0200

nqc (3.1.r6-8) unstable; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Use secure copyright file specification URI.
  * Bump debhelper from deprecated 9 to 13.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Archive, Repository.
  * Update Vcs-* headers to use salsa repository.
  * Replace use of deprecated $ADTTMP with $AUTOPKGTEST_TMP.

  [ Petter Reinholdtsen ]
  * Updated Standards-Version from 4.0.1 to 4.6.0.
  * Switch appstream metadata ID to reverse domain-name.
  * Mark package to not need root access during build.

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 26 Sep 2021 07:22:28 +0200
