=== debian/control ===
--- 
+++ 
@@ -3,12 +3,14 @@
 Priority: optional
 Maintainer: Debian LEGO Team <debian-lego-team@lists.alioth.debian.org>
 Uploaders:
- Petter Reinholdtsen <pere@debian.org>
-Build-Depends: debhelper (>= 9.0.0), dpkg-dev (>= 1.16.1~), bison, flex
-Standards-Version: 4.0.1
-Homepage: http://bricxcc.sourceforge.net/nqc/
-Vcs-Git: git://anonscm.debian.org/debian-lego/nqc.git
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-lego/nqc.git
+ Petter Reinholdtsen <pere@debian.org>,
+ Nicolas Schodet <nico@ni.fr.eu.org>,
+Build-Depends: debhelper-compat (= 13), bison, flex, binutils-h8300-hms
+Standards-Version: 4.7.2
+Homepage: https://bricxcc.sourceforge.net/nqc/
+Vcs-Git: https://salsa.debian.org/debian-lego-team/nqc.git
+Vcs-Browser: https://salsa.debian.org/debian-lego-team/nqc
+Rules-Requires-Root: no
 
 Package: nqc
 Architecture: any
