=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
# Upstream Makefile uses CFLAGS instead of CXXFLAGS and ignores CPPFLAGS.
CFLAGS = $(CXXFLAGS) $(CPPFLAGS)
CFLAGS_FOR_BUILD = $(CXXFLAGS_FOR_BUILD) $(CPPFLAGS_FOR_BUILD)

%:
	dh $@

override_dh_auto_build:
	dh_auto_build -- exec

override_dh_auto_install:
	dh_auto_install -- prefix=/usr

override_dh_installexamples:
	dh_installexamples
