## nqc 4.1.0%2Bdfsg

=== debian/changelog ===
nqc (4.1.0+dfsg-1) unstable; urgency=medium

  * New upstream version 4.1.0+dfsg:
    - Exclude non-DFSG files, or files with unknown license.
    - Update debian/copyright.
    - Add build dependency to pandoc and rsync for documentation.
    - Update build.
  * Use a fixed BUILD_DIR value.
  * Add remove-trackers.patch, removing trackers in HTML files.
  * Do not install archive of original documentation and large pictures.

 -- Nicolas Schodet <nico@ni.fr.eu.org>  Tue, 14 Oct 2025 22:20:04 +0200
